clear all
%Open data files
temp = load('IMU1_raw.mat');
imu1_raw = temp.ans;
temp = load('IMU2_raw.mat');
imu2_raw = temp.ans;
temp = load('IMU3_raw.mat');
imu3_raw = temp.ans;
temp = load('IMU4_raw.mat');
imu4_raw = temp.ans;
temp = load('oqus_measured.mat');
oqus = temp.ans;
load('rotation_matrix');

old1 = imu1_raw;
old2 = imu2_raw;
old3 = imu3_raw;
old4 = imu4_raw;

%Rotating according to 
imu1_raw(2:7,:) = Rot.imu1*imu1_raw(2:7,:);
imu2_raw(2:7,:) = Rot.imu2*imu2_raw(2:7,:);
imu3_raw(2:7,:) = Rot.imu3*imu3_raw(2:7,:);
imu4_raw(2:7,:) = Rot.imu4*imu4_raw(2:7,:);

%Rotating positive directions to align with body frame
imu1_raw(2:7,:) = diag([1, 1, 1, -1, -1, -1])*imu1_raw(2:7,:);
imu2_raw(2:7,:) = diag([-1, -1, 1, -1, -1, -1])*imu2_raw(2:7,:);
imu3_raw(2:7,:) = diag([-1, -1, 1, -1, -1, -1])*imu3_raw(2:7,:);
imu4_raw(2:7,:) = diag([1, 1, 1, -1, -1, -1])*imu4_raw(2:7,:);

for i=1:4
    figure()
    eval(sprintf('subplot(3,1,1);plot(imu%i_raw(1,:),imu%i_raw(2,:),imu%i_raw(1,:),old%i(2,:));legend(''Rotated'',''Raw'');',i,i,i,i));
    eval(sprintf('subplot(3,1,2);plot(imu%i_raw(1,:),imu%i_raw(3,:),imu%i_raw(1,:),old%i(3,:));legend(''Rotated'',''Raw'');',i,i,i,i));
    eval(sprintf('subplot(3,1,3);plot(imu%i_raw(1,:),imu%i_raw(4,:),imu%i_raw(1,:),old%i(4,:));legend(''Rotated'',''Raw'');',i,i,i,i));
end
%Lowpass filter properties:
Fs = 20;
Fpass = 2;
Fstop = 5;
Astop = 120;
Apass = 0.5;

df = designfilt('lowpassfir','StopbandFrequency',Fstop, ...
      'PassbandFrequency',Fpass,'StopbandAttenuation',Astop, ...
      'PassbandRipple',Apass,'SampleRate',Fs,'DesignMethod','equiripple');
  
D = round(mean(grpdelay(df)));

for i = 1:4
    eval(sprintf('omega_filt%i(1,:) = filter(df, imu%i_raw(2,:));',i,i));
    eval(sprintf('omega_filt%i(2,:) = filter(df, imu%i_raw(3,:));',i,i));
    eval(sprintf('omega_filt%i(3,:) = filter(df, imu%i_raw(4,:));',i,i));
    eval(sprintf('omega_filt%i(:,1:D) = [];',i));
end

figure()
subplot(3,1,1);plot(imu1_raw(1,:),imu1_raw(2,:),imu1_raw(1,1:end-D),omega_filt1(1,:));legend('raw','filtered');title('Roll');
subplot(3,1,2);plot(imu1_raw(1,:),imu1_raw(3,:),imu1_raw(1,1:end-D),omega_filt1(2,:));legend('raw','filtered');title('Pitch');
subplot(3,1,3);plot(imu1_raw(1,:),imu1_raw(4,:),imu1_raw(1,1:end-D),omega_filt1(3,:));legend('raw','filtered');title('Yaw');

omega1 = (omega_filt1(1,:)+omega_filt2(1,:)+omega_filt3(1,:)+omega_filt4(1,:))./4;
omega2 = (omega_filt1(2,:)+omega_filt2(2,:)+omega_filt3(2,:)+omega_filt4(2,:))./4;
omega3 = (omega_filt1(3,:)+omega_filt2(3,:)+omega_filt3(3,:)+omega_filt4(3,:))./4;

figure()
subplot(3,1,1);plot(omega1);
subplot(3,1,2);plot(omega2);
subplot(3,1,3);plot(omega3);