function [wave_angle] = wave_dir(measured_time, vel)


%Angles: 1->2, 1->3, 1->4
angle_offset = [0.5408, 1.3159, 1.5446];

%Lever arm
lever_arm = [sqrt((2*184)^2+(465-244)^2), sqrt((184+130)^2+(465+740)^2), sqrt((184-160)^2+(465+450)^2)];

step = deg2rad(1);

%Time difference
diff = 10;

wave_angle = 0;

for i = 0:10:360
    distance = [lever_arm(1)*cos(pi/2-angle_offset(1)-i*step),...
        lever_arm(2)*cos(pi/2-angle_offset(2)-i*step),...
        lever_arm(3)*cos(pi/2-angle_offset(3)-i*step)];
    
    time = [-distance(1)/vel, -distance(2)/vel, -distance(3)/vel];
    
    time_difference = [measured_time(1)-time(1), 1*(measured_time(2)-time(2)), 1*(measured_time(3)-time(3))];
    
    if sum(abs(time_difference)) < diff
        diff = sum(abs(time_difference));
        wave_angle = i;
    end
end

if wave_angle > 180
    wave_angle = wave_angle-360;
end

end